package DX::ActionBuilder::UnsetValue;

use DX::Action::SetValue;
use DX::ActionBuilder::Normal;
use DX::Action::BindValue;
use DX::ActionBuilder::BoundValue;
use DX::Class;

with 'DX::Role::ActionBuilder';

has target_path => (is => 'ro', required => 1);

sub action_for_set_value {
  my ($self, $value) = @_;
  if (my $p = $value->identity_path) {
    my $ab = DX::ActionBuilder::BoundValue->new(
      target_path => $self->target_path,
      rebind_path => $self->target_path,
      bound_to_path => $p,
      inner_action_builder => $value->action_builder,
    );
    return DX::Action::BindValue->new(
      target_path => $self->target_path,
      new_value => $value->but_set_action_builder($ab),
    )
  }
  my $ab = DX::ActionBuilder::Normal->new(
    target_path => $self->target_path,
  );
  DX::Action::SetValue->new(
    target_path => $self->target_path,
    new_value => $value->but_set_action_builder($ab)
                       ->but_set_identity_path($self->target_path),
  );
}

1;
